-- FIXME need caps for Critical Magnitude and Critical Defence

local version = 10.1

-- version history:

-- Big thanks to Polymnie
-- these code are copy and modify from Polymnie's StatCalc 10.1

-- Feel free to borrow or fork code, unless you're a jerk.

import "Turbine.UI"; -- this will expose the label control that we will implement
import "Turbine.UI.Lotro"; -- this will expose the standard window that we will implement
import "Turbine.Gameplay";

import "StatDiff.StatCalFunc";

local MyChar = Turbine.Gameplay.LocalPlayer:GetInstance();
local MyAttributes = MyChar:GetAttributes();
local MyClass = MyChar:GetClass();
local MyLevel

-------------------------------------------------------------------------------
function CheckClass()
	-- Freep
	if MyClass == Turbine.Gameplay.Class.Burglar or
	MyClass == Turbine.Gameplay.Class.Captain or
	MyClass == Turbine.Gameplay.Class.Champion or
	MyClass == Turbine.Gameplay.Class.Guardian or
	MyClass == Turbine.Gameplay.Class.Hunter or
	MyClass == Turbine.Gameplay.Class.LoreMaster or
	MyClass == Turbine.Gameplay.Class.Minstrel or
	MyClass == Turbine.Gameplay.Class.RuneKeeper or
	MyClass == Turbine.Gameplay.Class.Warden then
		return

	-- Creep
	elseif MyClass == Turbine.Gameplay.Class.BlackArrow or
	MyClass == Turbine.Gameplay.Class.Defiler or
	MyClass == Turbine.Gameplay.Class.Reaver or
	MyClass == Turbine.Gameplay.Class.Stalker or
	MyClass == Turbine.Gameplay.Class.WarLeader or
	MyClass == Turbine.Gameplay.Class.Weaver then
		Turbine.Shell.WriteLine(translate("Warning: StatDiff is broken for Monster Play classes.", Language))

	-- Session
	else
		Turbine.Shell.WriteLine(translate("Warning: StatDiff needs improvement for Session Play classes.", Language))
	end
end

-------------------------------------------------------------------------------

local Depth = 30;
local RowHeight = 20;
local WindowWidth = 530;
local WindowHeight = RowHeight * 33;

local Rows = {};
local myRows = {};
local myValues = {};

CalcWindow = Turbine.UI.Lotro.Window();
CalcWindow:SetPosition((Turbine.UI.Display:GetWidth() - WindowWidth) / 2, 0);
CalcWindow:SetSize(WindowWidth, WindowHeight);
CalcWindow:SetText("StatDiff "..version);
CalcWindow:SetVisible(true);

function MakeRow(stat, percent, substat)
	Rows[stat] = {};
	
	Rows[stat].name = MakeLabel(10, Depth, 180, RowHeight - 1, stat)
	if substat then
		Rows[stat].name:SetForeColor(Turbine.UI.Color(0.7, 0.7, 0.7))
	end

	-- stat1
	if not substat then
		Rows[stat].base = MakeLabel(200, Depth, 40, RowHeight - 1, nil, Turbine.UI.ContentAlignment.TopRight)
	end

	-- stat1 percentages
	if percent then
		Rows[stat].baseP = MakeLabel(250, Depth, 50, RowHeight - 1, nil, Turbine.UI.ContentAlignment.TopRight)
	end

	-- stat2
	if not substat then
		Rows[stat].delta = MakeLabel(310, Depth, 40, RowHeight - 1, nil, Turbine.UI.ContentAlignment.TopRight);
	end
	
	-- stat2 percentages
	if percent then
		Rows[stat].deltaP = MakeLabel(360, Depth, 50, RowHeight - 1, nil, Turbine.UI.ContentAlignment.TopRight)
	end
	
	-- diff result
	if not substat then
		Rows[stat].result = MakeLabel(420, Depth, 40, RowHeight - 1, nil, Turbine.UI.ContentAlignment.TopRight)
	end
	
	-- diff result percentages
	if percent then
		Rows[stat].resultP = MakeLabel(470, Depth, 50, RowHeight - 1, nil, Turbine.UI.ContentAlignment.TopRight)
	end

	-- increment
	Depth = Depth + RowHeight
	
	-- store labels by column in an array
	myRows[stat] = {};
	myRows[stat][0] = {};
	myRows[stat][0].base = Rows[stat].base;
	myRows[stat][0].baseP = Rows[stat].baseP;
	myRows[stat][1] = {};
	myRows[stat][1].base = Rows[stat].delta;
	myRows[stat][1].baseP = Rows[stat].deltaP;
	myRows[stat][2] = {};
	myRows[stat][2].base = Rows[stat].result;
	myRows[stat][2].baseP = Rows[stat].resultP;
	
	-- store values by column in an array
	myValues[stat] = {};
	myValues[stat][0] = {};
	myValues[stat][0].base = 0;
	myValues[stat][0].baseP = 0;
	myValues[stat][1] = {};
	myValues[stat][1].base = 0;
	myValues[stat][1].baseP = 0;
	--myValues[stat][2] = {};
	--myValues[stat][2].base = 0;
	--myValues[stat][2].baseP = 0;
end

function MakeLabel(Left, Top, Width, Height, Text, Alignment)
	local TempLabel = Turbine.UI.Label()
	TempLabel:SetFont(Turbine.UI.Lotro.Font.Verdana16)
	TempLabel:SetBackColor(Turbine.UI.Color(0.1, 0.1, 0.1))
	TempLabel:SetParent(CalcWindow)
	TempLabel:SetPosition(Left, Top)
	TempLabel:SetSize(Width, Height)
	TempLabel:SetMouseVisible(false)
	if Text then
		TempLabel:SetText(Text)
	end

	if Alignment then
		TempLabel:SetTextAlignment(Alignment)
	end

	return TempLabel
end

function MakeButton(Left, Top, Width, Height, Text)
	local TempButton = Turbine.UI.Lotro.Button()
	TempButton:SetParent(CalcWindow)
	TempButton:SetPosition(Left, Top)
	TempButton:SetSize(Width, Height)
	TempButton:SetFont(Turbine.UI.Lotro.Font.Verdana16)
	TempButton:SetText(Text)
	return TempButton
end

function PplValue(row, col, value, isPercent)
	if isPercent == nil or not isPercent then
		myRows[row][col].base:SetText(string.format("%.0f", value))
	else
		myRows[row][col].baseP:SetText(string.format("%.1f%%", value))
	end
end

function PplDiff(row, result, isPercent)
	local colour
	if result == 0 then
		colour = Turbine.UI.Color.White
	elseif result < 0 then
		colour = Turbine.UI.Color.Red
	elseif result > 0 then
		colour = Turbine.UI.Color.Lime
	else
		colour = Turbine.UI.Color.Yellow
	end
	
	if isPercent == nil or not isPercent then
		Rows[row].result:SetText(string.format("%.0f", result));
		Rows[row].result:SetForeColor(colour);
	else
		Rows[row].resultP:SetText(string.format("%.1f%%", result));
		Rows[row].resultP:SetForeColor(colour);
	end
end

MakeRow("Maximum Morale")
MakeRow("in-Combat Morale Regen")
MakeRow("non-Combat Morale Regen")
MakeRow("Maximum Power")
MakeRow("in-Combat Power Regen")
MakeRow("non-Combat Power Regen")
MakeRow("Armour")
MakeRow("Might")
MakeRow("Agility")
MakeRow("Vitality")
MakeRow("Will")
MakeRow("Fate")
MakeRow("Critical Hit", true)
MakeRow("Devastating Hit", true, true)
MakeRow("Critical Magnitude", true, true)
MakeRow("Finesse", true)
MakeRow("Physical Mastery", true)
MakeRow("Tactical Mastery", true)
MakeRow("Outgoing Healing", true, true)
MakeRow("Resistance", true)
MakeRow("Critical Defence", true)
MakeRow("Incoming Healing", true)
MakeRow("Block", true)
MakeRow("Partial Block", true, true)
MakeRow("Parry", true)
MakeRow("Partial Parry", true, true)
MakeRow("Evade", true)
MakeRow("Partial Evade", true, true)
MakeRow("Physical Mitigation", true)
MakeRow("Tactical Mitigation", true)

local StatButton1 = MakeButton(200, Depth, 60, 20, "Stat1")
StatButton1.Click = function()
	UpdateStat(0)
end

local StatButton2 = MakeButton(310, Depth, 60, 20, "Stat2")
StatButton2.Click = function()
	UpdateStat(1)
end

local DiffButton = MakeButton(420, Depth, 60, 20, "Diff")
DiffButton.Click = function()
	CalDiff()
end

function UpdateStat(col)
	MyLevel = MyChar:GetLevel();
	
	-- get current stat
	local morale1 = MyChar:GetMaxMorale();
	local icmr1 = MyAttributes:GetInCombatMoraleRegeneration() * 60; -- * 60
	local ncmr1 = MyAttributes:GetOutOfCombatMoraleRegeneration() * 60; -- * 60
	local power1 = MyChar:GetMaxPower();
	local icpr1 = MyAttributes:GetInCombatPowerRegeneration() * 60; -- * 60
	local ncpr1 = MyAttributes:GetOutOfCombatPowerRegeneration() * 60; -- * 60
	local armour1 = MyAttributes:GetArmor();
	local might1 = MyAttributes:GetMight();
	local agility1 = MyAttributes:GetAgility();
	local vitality1 = MyAttributes:GetVitality();
	local will1 = MyAttributes:GetWill();
	local fate1 = MyAttributes:GetFate();
	local crit1 = MyAttributes:GetBaseCriticalHitChance();
	local critPer = Avoidance(crit1, MyLevel) * 100;
	local devCritPer = PartialAvoidance(crit1, MyLevel) * 100;
	local critMagPer = CriticalMagnitude(crit1, MyLevel) * 100;
	local finesse1 = MyAttributes:GetFinesse();

	local physmas1
	if MyClass == Turbine.Gameplay.Class.Hunter then
		physmas1 = MyAttributes:GetRangeDamage();
	else
		physmas1 = MyAttributes:GetMeleeDamage();
	end
	
	local physmasPer = Offence(physmas1, MyLevel) * 100;

	local tacmas1 = MyAttributes:GetTacticalDamage();
	local tacmasPer = Offence(tacmas1, MyLevel) * 100;
	local outHealPer = Resistance(tacmas1, MyLevel) * 100;
	
	local resist1 = MyAttributes:GetBaseResistance();
	local resistPer = Resistance(resist1, MyLevel) * 100;
	local critdef1 = MyAttributes:GetBaseCriticalHitAvoidance();
	local critdefPer = CriticalDefence(critdef1, MyLevel) * 100;
	local incoming1 = MyAttributes:GetIncomingHealing();
	local incomingPer = Avoidance(incoming1, MyLevel) * 100;
	local block1 = MyAttributes:GetBlock();
	local blockPer = Avoidance(block1, MyLevel) * 100;
	local partialBlockPer = PartialAvoidance(block1, MyLevel) * 100;
	local parry1 = MyAttributes:GetParry();
	local parryPer = Avoidance(parry1, MyLevel) * 100;
	local partialParryPer = PartialAvoidance(parry1, MyLevel) * 100;
	local evade1 = MyAttributes:GetEvade();
	local evadePer = Avoidance(evade1, MyLevel) * 100;
	local partialEvadePer = PartialAvoidance(evade1, MyLevel) * 100;
	local physmit1 = MyAttributes:GetCommonMitigation(); -- not MyAttributes:GetPhysicalMitigation()
	local physmitPer = Mitigation(physmit1, MyLevel) * 100;
	local tacmit1 = MyAttributes:GetTacticalMitigation()
	local tacmitPer = Mitigation(tacmit1, MyLevel) * 100;
	
	-- store value for diff
	myValues["Maximum Morale"][col].base = morale1;
	myValues["in-Combat Morale Regen"][col].base = icmr1;
	myValues["non-Combat Morale Regen"][col].base = ncmr1;
	myValues["Maximum Power"][col].base = power1;
	myValues["in-Combat Power Regen"][col].base = icpr1;
	myValues["non-Combat Power Regen"][col].base = ncpr1;
	myValues["Armour"][col].base = armour1;
	myValues["Might"][col].base = might1;
	myValues["Agility"][col].base = agility1;
	myValues["Vitality"][col].base = vitality1;
	myValues["Will"][col].base = will1;
	myValues["Fate"][col].base = fate1;
	myValues["Critical Hit"][col].base = crit1;
	myValues["Critical Hit"][col].baseP = critPer;
	myValues["Devastating Hit"][col].baseP = devCritPer;
	myValues["Critical Magnitude"][col].baseP = critMagPer;
	myValues["Finesse"][col].base = finesse1;
	
	myValues["Physical Mastery"][col].base = physmas1;
	myValues["Physical Mastery"][col].baseP = physmasPer;
	
	myValues["Tactical Mastery"][col].base = physmas1;
	myValues["Tactical Mastery"][col].baseP = physmasPer;
	myValues["Outgoing Healing"][col].baseP = outHealPer;
	
	myValues["Resistance"][col].base = resist1;
	myValues["Resistance"][col].baseP = resistPer;
	myValues["Critical Defence"][col].base = critdef1;
	myValues["Critical Defence"][col].baseP = critdefPer;
	myValues["Incoming Healing"][col].base = incoming1;
	myValues["Incoming Healing"][col].baseP = incomingPer;
	
	myValues["Block"][col].base = block1;
	myValues["Block"][col].baseP = blockPer;
	myValues["Partial Block"][col].baseP = partialBlockPer;
	
	myValues["Parry"][col].base = parry1;
	myValues["Parry"][col].baseP = parryPer;
	myValues["Partial Parry"][col].baseP = partialParryPer;
	myValues["Evade"][col].base = evade1;
	myValues["Evade"][col].baseP = evadePer;
	myValues["Partial Evade"][col].baseP = partialEvadePer;
	myValues["Physical Mitigation"][col].base = physmit1;
	myValues["Physical Mitigation"][col].baseP = physmitPer;
	myValues["Tactical Mitigation"][col].base = tacmit1;
	myValues["Tactical Mitigation"][col].baseP = tacmitPer;
	
	-- ppl values
	PplValue("Maximum Morale", col, morale1);
	PplValue("in-Combat Morale Regen", col, icmr1);
	PplValue("non-Combat Morale Regen", col, ncmr1);
	PplValue("Maximum Power", col, power1);
	PplValue("in-Combat Power Regen", col, icpr1);
	PplValue("non-Combat Power Regen", col, ncpr1);
	PplValue("Armour", col, armour1);
	PplValue("Might", col, might1);
	PplValue("Agility", col, agility1);
	PplValue("Vitality", col, vitality1);
	PplValue("Will", col, will1);
	PplValue("Fate", col, fate1);
	PplValue("Critical Hit", col, crit1);
	PplValue("Critical Hit", col, critPer, true);
	PplValue("Devastating Hit", col, devCritPer, true);
	PplValue("Critical Magnitude", col, critMagPer, true);
	PplValue("Finesse", col, finesse1);
	
	PplValue("Physical Mastery", col, physmas1);
	PplValue("Physical Mastery", col, physmasPer, true);
	
	PplValue("Tactical Mastery", col, tacmas1);
	PplValue("Tactical Mastery", col, tacmasPer, true);
	PplValue("Outgoing Healing", col, outHealPer, true);
	
	PplValue("Resistance", col, resist1);
	PplValue("Resistance", col, resistPer, true);
	PplValue("Critical Defence", col, critdef1);
	PplValue("Critical Defence", col, critdefPer, true);
	PplValue("Incoming Healing", col, incoming1);
	PplValue("Incoming Healing", col, incomingPer, true);
	
	PplValue("Block", col, block1);
	PplValue("Block", col, blockPer, true);
	PplValue("Partial Block", col, partialBlockPer, true);
	
	PplValue("Parry", col, parry1);
	PplValue("Parry", col, parryPer, true);
	PplValue("Partial Parry", col, partialParryPer, true);
	PplValue("Evade", col, evade1);
	PplValue("Evade", col, evadePer, true);
	PplValue("Partial Evade", col, partialEvadePer, true);
	PplValue("Physical Mitigation", col, physmit1);
	PplValue("Physical Mitigation", col, physmitPer, true);
	PplValue("Tactical Mitigation", col, tacmit1);
	PplValue("Tactical Mitigation", col, tacmitPer, true);
end

function DiffValue(row, isPercent)
	local value1;
	if isPercent == nil or not isPercent then
		value1 = myValues[row][0].base;
	else
		value1 = myValues[row][0].baseP;
	end
	
	local value2;
	if isPercent == nil or not isPercent then
		value2 = myValues[row][1].base;
	else
		value2 = myValues[row][1].baseP;
	end
	
	return value2 - value1;
end

function CalDiff()
	local morale = DiffValue("Maximum Morale");
	local icmr = DiffValue("in-Combat Morale Regen");
	local ncmr = DiffValue("non-Combat Morale Regen");
	local power = DiffValue("Maximum Power");
	local icpr = DiffValue("in-Combat Power Regen");
	local ncpr = DiffValue("non-Combat Power Regen");
	local armour = DiffValue("Armour");
	local might = DiffValue("Might");
	local agility = DiffValue("Agility");
	local vitality = DiffValue("Vitality");
	local will = DiffValue("Will");
	local fate = DiffValue("Fate");
	local crit = DiffValue("Critical Hit");
	local critPer = DiffValue("Critical Hit", true);
	local devCritPer = DiffValue("Devastating Hit", true);
	local critMagPer = DiffValue("Critical Magnitude", true);
	local finesse = DiffValue("Finesse");
	
	local physmas1 = DiffValue("Physical Mastery");
	local physmasPer = DiffValue("Physical Mastery", true);
	
	local tacmas1 = DiffValue("Tactical Mastery");
	local tacmasPer = DiffValue("Tactical Mastery", true);
	local outHealPer = DiffValue("Outgoing Healing", true);
	
	local resist1 = DiffValue("Resistance");
	local resistPer = DiffValue("Resistance", true);
	local critdef1 = DiffValue("Critical Defence");
	local critdefPer = DiffValue("Critical Defence", true);
	local incoming1 = DiffValue("Incoming Healing");
	local incomingPer = DiffValue("Incoming Healing", true);
	
	local block1 = DiffValue("Block");
	local blockPer = DiffValue("Block", true);
	local partialBlockPer = DiffValue("Partial Block", true);
	
	local parry1 = DiffValue("Parry");
	local parryPer = DiffValue("Parry", true);
	local partialParryPer = DiffValue("Partial Parry", true);
	local evade1 = DiffValue("Evade");
	local evadePer = DiffValue("Evade", true);
	local partialEvadePer = DiffValue("Partial Evade", true);
	local physmit1 = DiffValue("Physical Mitigation");
	local physmitPer = DiffValue("Physical Mitigation", true);
	local tacmit1 = DiffValue("Tactical Mitigation");
	local tacmitPer = DiffValue("Tactical Mitigation", true);
	
	-- ppl diff
	PplDiff("Maximum Morale", morale);
	PplDiff("in-Combat Morale Regen", icmr);
	PplDiff("non-Combat Morale Regen", ncmr);
	PplDiff("Maximum Power", power);
	PplDiff("in-Combat Power Regen", icpr);
	PplDiff("non-Combat Power Regen", ncpr);
	PplDiff("Armour",armour);
	PplDiff("Might", might);
	PplDiff("Agility", agility);
	PplDiff("Vitality", vitality);
	PplDiff("Will", will);
	PplDiff("Fate", fate);
	PplDiff("Critical Hit", crit);
	PplDiff("Critical Hit", critPer, true);
	PplDiff("Devastating Hit", devCritPer, true);
	PplDiff("Critical Magnitude", critMagPer, true);
	PplDiff("Finesse", finesse);
	
	PplDiff("Physical Mastery", physmas1);
	PplDiff("Physical Mastery", physmasPer, true);
	
	PplDiff("Tactical Mastery", tacmas1);
	PplDiff("Tactical Mastery", tacmasPer, true);
	PplDiff("Outgoing Healing", outHealPer, true);
	
	PplDiff("Resistance", resist1);
	PplDiff("Resistance", resistPer, true);
	PplDiff("Critical Defence", critdef1);
	PplDiff("Critical Defence", critdefPer, true);
	PplDiff("Incoming Healing", incoming1);
	PplDiff("Incoming Healing", incomingPer, true);
	
	PplDiff("Block", block1);
	PplDiff("Block", blockPer, true);
	PplDiff("Partial Block", partialBlockPer, true);
	
	PplDiff("Parry", parry1);
	PplDiff("Parry", parryPer, true);
	PplDiff("Partial Parry", partialParryPer, true);
	PplDiff("Evade", evade1);
	PplDiff("Evade", evadePer, true);
	PplDiff("Partial Evade", partialEvadePer, true);
	PplDiff("Physical Mitigation", physmit1);
	PplDiff("Physical Mitigation", physmitPer, true);
	PplDiff("Tactical Mitigation", tacmit1);
	PplDiff("Tactical Mitigation", tacmitPer, true);
end

-------------------------------------------------------------------------------
local CommandLine = Turbine.ShellCommand()
CommandLine.Execute = function(sender, cmd, args)
	if not CalcWindow:IsVisible() then
		CalcWindow:SetVisible(true)
	end
end

Turbine.Shell.AddCommand("StatDiff", CommandLine);

-------------------------------------------------------------------------------
-- create a dummy window, and update until loaded, at which point set loaded=true and set the unload commands.
local loaded = false
tmpWindow = Turbine.UI.Window()
tmpWindow.Update = function()
	if Plugins["StatDiff"] ~= nil and not loaded then
		loaded = true
		Plugins["StatDiff"].Unload = function()
			Turbine.Shell.RemoveCommand(CommandLine)
		end
		tmpWindow:SetWantsUpdates(false);
		Turbine.Shell.WriteLine("StatDiff plugin loaded.");
		CheckClass();
	end
end
tmpWindow:SetWantsUpdates(true);